from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Int, Boolean

Treebest_Nj_V0_1_0 = CommandToolBuilder(tool="treebest_nj", base_command=["treebest", "nj"], inputs=[ToolInput(tag="in_constrained_trees_nh", input_type=File(optional=True), prefix="-c", doc=InputDocumentation(doc="constrained tree(s) in NH format [null]")), ToolInput(tag="in_tree_to_compared", input_type=File(optional=True), prefix="-m", doc=InputDocumentation(doc="tree to be compared [null]")), ToolInput(tag="in_species_tree_nh", input_type=File(optional=True), prefix="-s", doc=InputDocumentation(doc="species tree in NH format [default taxa tree]")), ToolInput(tag="in_ingroup_list_file", input_type=File(optional=True), prefix="-l", doc=InputDocumentation(doc="ingroup list file [null]")), ToolInput(tag="in_codon_nt_ntmm", input_type=String(optional=True), prefix="-t", doc=InputDocumentation(doc="codon NT: ntmm, dn, ds, dm; AA: mm, jtt, kimura [mm]")), ToolInput(tag="in_time_limit_seconds", input_type=Int(optional=True), prefix="-T", doc=InputDocumentation(doc="time limit in seconds [no limit]")), ToolInput(tag="in_bootstrapping_times", input_type=Int(optional=True), prefix="-b", doc=InputDocumentation(doc="bootstrapping times [100]")), ToolInput(tag="in_quality_cutoff", input_type=Int(optional=True), prefix="-F", doc=InputDocumentation(doc="quality cut-off [15]")), ToolInput(tag="in_outgroup_tree_cutting", input_type=String(optional=True), prefix="-o", doc=InputDocumentation(doc="outgroup for tree cutting [Bilateria]")), ToolInput(tag="in_treat_first_tree", input_type=Boolean(optional=True), prefix="-S", doc=InputDocumentation(doc="treat the first constrained tree as the original tree")), ToolInput(tag="in_use_leaves_constrained", input_type=Boolean(optional=True), prefix="-C", doc=InputDocumentation(doc="use the leaves of constrained trees as ingroup")), ToolInput(tag="in_apply_alignment_mask", input_type=Boolean(optional=True), prefix="-M", doc=InputDocumentation(doc="do not apply alignment mask")), ToolInput(tag="in_mask_aligned_segments", input_type=Boolean(optional=True), prefix="-N", doc=InputDocumentation(doc="do not mask poorly aligned segments")), ToolInput(tag="in_collapse_alternative_splicing", input_type=Boolean(optional=True), prefix="-g", doc=InputDocumentation(doc="collapse alternative splicing")), ToolInput(tag="in_do_apply_leafreordering", input_type=Boolean(optional=True), prefix="-R", doc=InputDocumentation(doc="do not apply leaf-reordering")), ToolInput(tag="in_root_node_putative", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="the root node is a putative node")), ToolInput(tag="in_branch_mode_used", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc="branch mode that is used by most tree-builder")), ToolInput(tag="in_input_alignment_stored", input_type=Boolean(optional=True), prefix="-A", doc=InputDocumentation(doc="the input alignment is stored in ALN format")), ToolInput(tag="in_wipe_sdi_information", input_type=Boolean(optional=True), prefix="-W", doc=InputDocumentation(doc="wipe out root (SDI information will be lost!)")), ToolInput(tag="in_copy_branch_support", input_type=Boolean(optional=True), prefix="-I", doc=InputDocumentation(doc="copy the branch support tags from the constrained tree")), ToolInput(tag="in_verbose_output", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="verbose output")), ToolInput(tag="in_nt_mm", input_type=String(), position=0, doc=InputDocumentation(doc="p-distance (codon alignment)")), ToolInput(tag="in_dn", input_type=String(), position=1, doc=InputDocumentation(doc="non-synonymous distance")), ToolInput(tag="in_ds", input_type=String(), position=2, doc=InputDocumentation(doc="synonymous distance")), ToolInput(tag="in_dm", input_type=String(), position=3, doc=InputDocumentation(doc="dn-ds merge (tree merge)")), ToolInput(tag="in_mm", input_type=String(), position=4, doc=InputDocumentation(doc="p-distance (amino acid alignment)")), ToolInput(tag="in_jtt", input_type=String(), position=5, doc=InputDocumentation(doc="JTT model (maximum likelihood)")), ToolInput(tag="in_kimura", input_type=String(), position=6, doc=InputDocumentation(doc="mm + Kimura's correction"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Treebest_Nj_V0_1_0().translate("wdl", allow_empty_container=True)

